from osc import cmdln

@cmdln.option('--overwrite', action='store_true',
              help='Overwrite files with the same name')
@cmdln.option('--nuke-link-file', action='store_true',
              help='Delete the _link file in the working directory')
@cmdln.option('--local', action='store_true',
              help='Attempt to do this locally. (Unimplemented)')
@cmdln.option('--commit', action='store_true',
              help='Automagically commit.  This probably only makes sense if --overwrite is set.')

@cmdln.alias('ld')
@cmdln.alias('deref')
def do_linkdereference(self, subcmd, opts):
    """${cmd_name}: Dereference a linked package.
    
    Examples:
      linkdeference
      linkdereference --overwrite

    ${cmd_usage}
    ${cmd_option_list}"""

    import xml.parsers.expat

    # python can be so annoying sometimes
    linkderef_project =  [""]
    linkderef_package = [""]
    
    def start_element(name, attrs):
        if name == "link":
            linkderef_project[0] = attrs[u'project']
            linkderef_package[0] = attrs[u'package']
            pass
        pass
    
    p = xml.parsers.expat.ParserCreate()
    p.StartElementHandler = start_element

    lines = open("_link").readlines()
    lines = reduce(lambda n, m: n + m, lines)
    
    p.Parse(lines, 1)

    print "so, the project is %s and the package is %s" % \
        (linkderef_project[0], linkderef_package[0])

    proj = linkderef_project[0]
    pack = linkderef_package[0]
    
    files = meta_get_filelist(conf.config['apiurl'], proj, pack)
    for file in files:
        if opts.overwrite:
            target = file
        else:
            target = "%s.new" % file
            pass
        get_source_file(conf.config['apiurl'], proj, pack, file, targetfilename=target)
        print "checked out %s" % target
        if opts.commit and opts.overwrite:
            os.system("osc add %s" % target)
        
    if opts.nuke_link_file:
        print "about to nuke the _link file"
        os.system("osc rm _link")

    pass


# _link files look like this:
### <link project="openSUSE:Factory" package="evolution">
### <patches>
###   <!-- <apply name="patch" /> -->
###   <!-- <topadd>%define build_with_feature_x 1</topadd> -->
### </patches>
### </link>
