from osc import cmdln

@cmdln.option('--user', metavar='user',
              help="list branch repos owned by someone other than you")
@cmdln.option('-l', '--list-packages', action='store_true', metavar='list_packages',
              help="list packages in your branch repositories")


def do_mybranches(self, subcmd, opts):
    """${cmd_name}: List your branches.
    
    ${cmd_usage}
    ${cmd_option_list}
    """

    import re

    if not opts.user:
        me = conf.config['user']
    else:
        me = opts.user
        pass
    
    apiurl = conf.config['apiurl']
    
    projects = meta_get_project_list(apiurl)
    
    for project in projects:
        prefix = "home:%s:branches:" % me
        if project.startswith(prefix):
            if opts.list_packages:
                print "%s:" % project
                pacs = meta_get_packagelist(apiurl, project)
                paccount = 0
                for pac in pacs:
                    print "+ %s" % pac
                    paccount = paccount + 1
                if paccount == 0:
                    print "(none)"
            else:
                print project

            

    
