from osc import cmdln

# First cut at a patchlinting extension.  Right now this doesn't do much
# useful work, but we can improve it as we go.

@cmdln.option('--standard', metavar='STANDARD',
              help="the patch standard we want to apply (defaults to 'gnome'")
@cmdln.option('--package', metavar='PACKAGE',
              help='only patches for this package')

def do_patchlint(self, subcmd, opts, project):
    """${cmd_name}: Display a summary of misnamed patches within a package or repository

    Examples:
       patchlint GNOME:UNSTABLE
       patchlint --package=abiword GNOME:UNSTABLE
       patchlint --package=abiword --standard=gnome GNOME:UNSTABLE
       
    ${cmd_usage}
    ${cmd_option_list}
    """

    from oscpluginsgnome import standards as stds

    func = stds.get_patch_standard(opts.standard)
    
    packages = meta_get_packagelist(conf.config['apiurl'], project)

    for package in packages:
        if opts.package and package != opts.package:
            continue

        print "Patch summary for package %s:" % package

        files = meta_get_filelist(conf.config['apiurl'], project, package)
        patch_count = 0
        for file in files:
            extension = os.path.splitext(file)[1]
            if extension == ".patch" or extension == ".diff" or extension == ".dif":
                patch_count += 1
                func(package, file)
        if patch_count == 0:
            print "\tNo patches for %s.  Hooray!" % package
                
        # collect statistics, print them out, etc

